javax.servlet.jsp.tagext

## Class TagLibraryValidator

- java.lang.Object
- - javax.servlet.jsp.tagext.TagLibraryValidator

    public abstract class TagLibraryValidator
    extends java.lang.Object

Translation-time validator class for a JSP page. A validator operates on the XML view associated with the JSP page.

The TLD file associates a TagLibraryValidator class and some init arguments with a tag library.

The JSP container is responsible for locating an appropriate instance of the appropriate subclass by

- new a fresh instance, or reuse an available one
- invoke the setInitParams(Map) method on the instance

once initialized, the validate(String, String, PageData) method will be invoked, where the first two arguments are the prefix and uri for this tag library in the XML View. The prefix is intended to make it easier to produce an error message. However, it is not always accurate. In the case where a single URI is mapped to more than one prefix in the XML view, the prefix of the first URI is provided. Therefore, to provide high quality error messages in cases where the tag elements themselves are checked, the prefix parameter should be ignored and the actual prefix of the element should be used instead. TagLibraryValidators should always use the uri to identify elements as belonging to the tag library, not the prefix.

A TagLibraryValidator instance may create auxiliary objects internally to perform the validation (e.g. an XSchema validator) and may reuse it for all the pages in a given translation run.

The JSP container is not guaranteed to serialize invocations of validate() method, and TagLibraryValidators should perform any synchronization they may require.

As of JSP 2.0, a JSP container must provide a jsp:id attribute to provide higher quality validation errors. The container will track the JSP pages as passed to the container, and will assign to each element a unique "id", which is passed as the value of the jsp:id attribute. Each XML element in the XML view available will be extended with this attribute. The TagLibraryValidator can then use the attribute in one or more ValidationMessage objects. The container then, in turn, can use these values to provide more precise information on the location of an error.

The actual prefix of the `id` attribute may or may not be `jsp` but it will always map to the namespace `http://java.sun.com/JSP/Page`. A TagLibraryValidator implementation must rely on the uri, not the prefix, of the `id` attribute.

### Constructor Summary

Constructors
Constructor and Description
`TagLibraryValidator()` Sole constructor.

### Method Summary

All Methods Instance Methods Concrete Methods
`java.util.Map<java.lang.String,java.lang.Object>` `getInitParameters()` Get the init parameters data as an immutable Map.
`void` `release()` Release any data kept by this instance for validation purposes.
`void` `setInitParameters(java.util.Map<java.lang.String,java.lang.Object> map)` Set the init data in the TLD for this validator.
`ValidationMessage[]` `validate(java.lang.String prefix, java.lang.String uri, PageData page)` Validate a JSP page.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### TagLibraryValidator

    public TagLibraryValidator()

Sole constructor. (For invocation by subclass constructors, typically implicit.)

### Method Detail

#### setInitParameters

    public void setInitParameters(java.util.Map<java.lang.String,java.lang.Object> map)

Set the init data in the TLD for this validator. Parameter names are keys, and parameter values are the values.

Parameters:
  `map` - A Map describing the init parameters

#### getInitParameters

    public java.util.Map<java.lang.String,java.lang.Object> getInitParameters()

Get the init parameters data as an immutable Map. Parameter names are keys, and parameter values are the values.

Returns:
  The init parameters as an immutable map.

#### validate

    public ValidationMessage[] validate(java.lang.String prefix,
                                        java.lang.String uri,
                                        PageData page)

Validate a JSP page. This will get invoked once per unique tag library URI in the XML view. This method will return null if the page is valid; otherwise the method should return an array of ValidationMessage objects. An array of length zero is also interpreted as no errors.

Parameters:
  `prefix` - the first prefix with which the tag library is associated, in the XML view. Note that some tags may use a different prefix if the namespace is redefined.
  `uri` - the tag library's unique identifier
  `page` - the JspData page object
Returns:
  A null object, or zero length array if no errors, an array of ValidationMessages otherwise.

#### release

    public void release()

Release any data kept by this instance for validation purposes.